% Autor:
% Datum: 05.03.03

startsymbol([vS]).
produktion([vS], [a,vS,vB,vC]).
produktion([vS], [a,vB,vC]).
produktion([vC,vB], [vB,vC]).
produktion([a,vB], [a,b]).
produktion([b,vB], [b,b]).
produktion([b,vC], [b,c]).
produktion([c,vC], [c,c]).


ableitungsschritt(AltesWort, NeuesWort) :-
   produktion(L,R),
   append(L,B,AltesWort),
   append(R,B,NeuesWort).

ableitungsschritt([E|AltesWort], [E|NeuesWort]) :-
   ableitungsschritt(AltesWort, NeuesWort).

ableitungskette(NeuesWort, AltesWort) :-
   AltesWort = NeuesWort.

ableitungskette(NeuesWort, AltesWort) :-
   ableitungsschritt(ZwischenWort, NeuesWort),
   ableitungskette(ZwischenWort, AltesWort).

ableitung(Wort) :-
   ableitungskette(Wort, S),
   startsymbol(S).
