% Autor:
% Datum: 05.03.03

startsymbol([vS]).
produktion([vS], [a,vS,vB,vC]).
produktion([vS], [a,vB,vC]).
produktion([vC,vB], [vB,vC]).
produktion([a,vB], [a,b]).
produktion([b,vB], [b,b]).
produktion([b,vC], [b,c]).
produktion([c,vC], [c,c]).

ableitungsschritt(AltesWort, L, R, NeuesWort) :-
   produktion(L,R),
   append(L,B,AltesWort),
   append(R,B,NeuesWort).

ableitungsschritt([E|AltesWort], L, R, [E|NeuesWort]) :-
   ableitungsschritt(AltesWort, L, R, NeuesWort).

ableitungskette(NeuesWort, AltesWort,[]) :-
   AltesWort = NeuesWort.

ableitungskette(NeuesWort, AltesWort, [regel(L,R), ZwischenWort |RAbleitung]) :-
   ableitungsschritt(ZwischenWort, L, R, NeuesWort),
   ableitungskette(ZwischenWort, AltesWort, RAbleitung).

ableitung(Wort) :-
   ableitungskette(Wort, S, A),
   startsymbol(S),
   write(A).

