% Autor:
% Datum: 06.03.04

% ASCII-Listen vergleichen
kleiner([], [_E|_R]).
kleiner([K|_R], [K1|_R1]) :- K < K1.
kleiner([K|R], [K1|R1]) :- K = K1, kleiner(R, R1).

% Atome vergleichen
vor(A, B) :- name(A, LA), name(B, LB), kleiner(LA, LB).

% Einfgen in eine sortierte Liste
ins(E, [], [E]).
ins(E, [E|R], [E|[E|R]]).
ins(E, [K|R], [E | [K |R]]) :- vor(E, K).
ins(E, [K|R], [K|M]) :- vor(K, E), ins(E, R, M).

% Sortieren durch Einfgen
inssort([], []).
inssort([K|R], L) :- inssort(R, M), ins(K, M, L).
