% Autor:
% Datum: 06.03.03

:- dynamic email/2.

email(a,['a@aol.de', 'a@t-online.de']).
email(b,['b@aol.de', 'b@web.de', 'b@gmx.de']).
email(c,['c@gmx.de']).
email(d,['d@d.de', 'd@t-online.de']).


add1(X,L,[X|L]).

add2(X,[],[X]).
add2(X,[X|R],[X|R]).
add2(X,[Y|R],[Y|N]) :- X \= Y, add2(X,R,N).


addemail(Person, Adresse, NeueListe) :-
  email(Person, AlteListe),
  add2(Adresse, AlteListe, NeueListe),
  retract(email(Person, AlteListe)),
  assertz(email(Person, NeueListe)).


  
speichern :-
  tell('Emaildaten.pl'),
  listing(email), told.
  
  


